/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: ControlList.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005-09-09 06:30:16 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef SD_TOOLPANEL_CONTROL_LIST_HXX
#define SD_TOOLPANEL_CONTROL_LIST_HXX

#include "ConstrainedIterator.hxx"
#include "ConstrainedIterator.cxx"
#include "TitledControl.hxx"

#include <vector>

namespace sd { namespace toolpanel {


typedef ::std::vector<TitledControl*> ControlList;
typedef ConstrainedIterator<ControlList> ControlIterator;


class VisibilityConstraint
    : public Constraint<ControlList>
{
public:
    virtual bool operator() (
        const ControlList& rContainer,
        const ControlList::iterator& rIterator) const
    {
        return (**rIterator).GetWindow()->IsVisible();
    }
};


} } // end of namespace ::sd::toolpanel

#endif
